/*
 * Copyright (C) 2009 Saulo Popov Zambiasi
 *
 * This source code is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Subverse is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact: saulopz@gmail.com
 */

#include "Globals.h"
#include "Enjin.h"

class Game {
private:
	Enjin *enjin;
	Image *button;
	bool exitGame;
	int x, y;
public:
	Game();
	void render();
	void simulateGameWorld();
	void processInput();
	void gameLoop();
	~Game();
};

Game::Game() {
	enjin = new Enjin();
	enjin->set("Teste de mouse", 800, 600);
	enjin->loadSprite("../../midia/img/greenBackground.jpg","greenBackground");
	enjin->loadSprite("../../midia/img/btoff.png","btoff");
	enjin->loadSprite("../../midia/img/bton.png","bton");
	enjin->loadSprite("../../midia/img/btout.png","btout");
	button = enjin->getSprite("btoff");
	exitGame = false;
	x = 100;
	y = 100;
    gameLoop();
}

void Game::render() {
	enjin->drawImage(enjin->getSprite("greenBackground"), enjin->screen, 0, 0, 255);
	enjin->drawImage(button, enjin->screen, x, y, 255);
	enjin->drawScreen();
}

void Game::simulateGameWorld(){
    if (enjin->isMouseDown()) {
        if (enjin->getMouseButton() == 1) {
            if ((enjin->getMouseX() > x) && (enjin->getMouseX() < x + button->w) &&
                (enjin->getMouseY() > y) && (enjin->getMouseY() < y + button->h)) {
                button = enjin->getSprite("bton");
            } else {
                button = enjin->getSprite("btout");
            }
         }
        if (enjin->getMouseButton() == 3) {
            x = enjin->getMouseX() - (int) (button->w / 2);
            y = enjin->getMouseY() - (int) (button->h / 2);
        }
    } else if (enjin->isMouseUp()) {
        button = enjin->getSprite("btoff");
    }
    if (enjin->isKeyDown(SDLK_ESCAPE)) {
        exitGame = true;
    }
}

void Game::processInput() {
    enjin->updateEvents();
}

void Game::gameLoop() {
    while (!exitGame) {
        render();
        processInput();
        simulateGameWorld();
    }
}

Game::~Game() {
    delete enjin;
}

int main (int argc, char* argv[]) {
    Game game;
	return 0;
}
